--- .empty	Thu Jan  1 00:00:00 1970
+++ NEW/xc/programs/Xserver/hw/sun/sunBSDTCX.c	Thu Jan  1 00:00:00 1970
@@ -0,0 +1,435 @@
+typedef struct tcx24 TCX24;
+typedef struct brooktree BROOKTREE;
+
+struct brooktree {
+  unsigned int addr;
+  unsigned int cmap;
+  unsigned int ctrl;
+  unsigned int omap;
+  } ;
+
+struct tcx24 {
+  unsigned long int *pseudo1;
+  volatile unsigned long int *vm8;
+  volatile unsigned long int *vm24;
+  volatile unsigned long int *vm32;
+  volatile BROOKTREE *bt;
+  } ;
+
+static int win_pi;
+static int gc_pi;
+static int font_pi;
+
+/* The EnterLeave member is declared as taking old-style arguments, ugh */
+static void null_enterleave(a,b)
+ScreenPtr a;
+int b;
+{
+}
+
+static Bool tcx_CreateDefColormap(ScreenRec *scr)
+{
+ VisualRec *v;
+ ColormapRec *cm;
+ Pixel p;
+ unsigned short int v;
+
+ for (v=scr->visuals;v->vid!=scr->rootVisual;v++) ;
+ if (CreateColormap(scr->defColormap,scr,v,&cm,AllocNone,0) != Success) return(FALSE);
+ v = 0;
+ if (AllocColor(cm,&v,&v,&v,&p) != Success) return(FALSE);
+ scr->blackPixel = p;
+ v = ~0;
+ if (AllocColor(cm,&v,&v,&v,&p) != Success) return(FALSE);
+ scr->whitePixel = p;
+ (*scr->InstallColormap)(cmap);
+ return(TRUE);
+}
+
+static Bool tcx_CloseScreen(int inx, ScreenRec *scr)
+{
+ xfree(scr->allowedDepths[1].vids);
+ xfree(scr->allowedDepths);
+ xfree(scr->visuals);
+ xfree(scr->devPrivate);
+}
+
+static void tcx_QueryBestSize(int class, unsigned short int *wp, unsigned short int *hp, ScreenRec *scr)
+{
+ switch (class)
+  { case CursorShape:
+       if (*wp > 1152) *wp = 1152;
+       if (*hp > 900) *hp = 900;
+       break;
+    case TileShape:
+    case StippleShape:
+	{ unsigned int w;
+	  int s;
+	  w = *wp;
+	  if (w & (w-1))
+	   { for (s=1;w&(w+1);s<<=1) w |= w >> s;
+	     *wp = w + 1;
+	   }
+	}
+       break;
+  }
+}
+
+static Bool tcx_SaveScreen(ScreenRec *scr, int state)
+{
+ int onoff;
+
+ switch (state)
+  { case SCREEN_SAVER_FORCER:
+       break;
+    case SCREEN_SAVER_ON:
+       onoff = 0;
+       if (0)
+	{
+    case SCREEN_SAVER_OFF:
+	  onoff = 1;
+	}
+       ioctl(sunFbs[scr->myNum].fd,FBIOSVIDEO,&onoff);
+       break;
+  }
+}
+
+static void tcx_GetSpans(DrawableRec *d, int wmax, DDXPointRec *
+pts, int *widths, int nspans, char *to)
+{
+ if (d->type == DRAWABLE_WINDOW)
+  { switch (d->bitsPerPixel)
+     { case 1:
+	  break;
+       case 8:
+	  break;
+       case 24:
+	  break;
+       default:
+	  FatalError("tcx_GetSpans: invalid depth (window)\n");
+	  break;
+     }
+  }
+ else
+  { switch (d->bitsPerPixel)
+     { case 1:
+	  mfbGetSpans(d,wmax,pts,widths,nsspans,to);
+	  break;
+       case 8:
+	  cfbGetSpans(d,wmax,pts,widths,nspans,to);
+	  break;
+       case 24:
+	  cfb32GetSpans(d,wmax,pts,widths,nspans,to);
+	  break;
+       default:
+	  FatalError("tcx_GetSpans: invalid depth (!window)\n");
+	  break;
+     }
+  }
+}
+
+static Bool tcx_CreateWindow(WindowRec *w)
+{
+ switch (w->drawable.depth)
+  { case 8: return(cfbCreateWindow(w)); break;
+    case 24: return(cfb32CreateWindow(w)); break;
+  }
+ FatalError("tcx_CreateWindow: invalid depth\n");
+}
+
+static Bool tcx_DestroyWindow(WindowRec *w)
+{
+ switch (w->drawable.depth)
+  { case 8: return(cfbDestroyWindow(w)); break;
+    case 24: return(cfb32DestroyWindow(w)); break;
+  }
+ FatalError("tcx_DestroyWindow: invalid depth\n");
+}
+
+tcx_PositionWindow;
+tcx_ChangeWindowAttributes;
+tcx_MapWindow;
+tcx_UnmapWindow;
+tcx_PaintWindow;
+tcx_PaintWindow;
+tcx_CopyWindow;
+tcx_CreatePixmap;
+tcx_DestroyPixmap;
+tcx_ConstrainCursor;
+tcx_CursorLimits;
+tcx_DisplayCursor;
+tcx_RealizeCursor;
+tcx_UnrealizeCursor;
+tcx_RecolorCursor;
+tcx_SetCursorPosition;
+tcx_CreateGC;
+tcx_CreateColormap;
+tcx_DestroyColormap;
+tcx_InstallColormap;
+tcx_UninstallColormap;
+tcx_ListInstalledColormaps;
+tcx_StoreColors;
+tcx_ResolveColor;
+
+Bool sunBSDTCXInit(int scrno, ScreenRec *scr, int argc, char **argv)
+{
+ VisualRec *visuals;
+ DepthRec *depths;
+ int fd;
+ void *vm1;
+ void *vm8;
+ void *vm24;
+ void *vm32;
+ void *bt;
+ TCX24 *t;
+ VisualRec *v;
+ VisualRec *rootv;
+
+ if (scrno != 0) return(FALSE); /* XXX */
+ win_pi = AllocateWindowPrivateIndex();
+ gc_pi = AllocateGCPrivateIndex();
+ font_pi = AllocateFontPrivateIndex();
+ if (! AllocateWindowPrivate(scr,win_pi,sizeof(tcx_winp))) return(FALSE);
+ if (! AllocateGCPrivate(scr,gc_pi,sizeof(tcx_gcp))) return(FALSE);
+ sunFbs[screen].EnterLeave = null_enterleave;
+ fd = sunFbs[screen].fd;
+ vm1 = mmap(0,(1152/8)*900,PROT_READ|PROT_WRITE,MAP_ANON|MAP_PRIVATE,-1,0);
+ if (vm1 == MAP_FAILED) return(FALSE);
+ vm8 = mmap(0,1152*900,PROT_READ|PROT_WRITE,MAP_FILE|MAP_SHARED,fd,0);
+ if (vm8 == MAP_FAILED)
+  { munmap(vm1,(1152/8)*900);
+    return(FALSE);
+  }
+ vm24 = mmap(0,1152*900*4,PROT_READ|PROT_WRITE,MAP_FILE|MAP_SHARED,fd,0x01000000);
+ if (vm24 == MAP_FAILED)
+  { munmap(vm1,(1152/8)*900);
+    munmap(vm8,1152*900);
+    return(FALSE);
+  }
+ vm32 = mmap(0,1152*900*4,PROT_READ|PROT_WRITE,MAP_FILE|MAP_SHARED,fd,0x28000000);
+ if (vm32 == MAP_FAILED)
+  { munmap(vm1,(1152/8)*900);
+    munmap(vm8,1152*900);
+    munmap(vm24,1152*900*4);
+    return(FALSE);
+  }
+ bt = mmap(0,sizeof(struct brooktree),PROT_READ|PROT_WRITE,MAP_FILE|MAP_SHARED,fd,0x70002000);
+ if (bt == MAP_FAILED)
+  { munmap(vm1,(1152/8)*900);
+    munmap(vm8,1152*900);
+    munmap(vm24,1152*900*4);
+    munmap(vm32,1152*900*4);
+    return(FALSE);
+  }
+ sunFbs[screen].fb = 0;
+ depths = xalloc(4*sizeof(DepthRec));
+ depths[0].depth = 1;
+ depths[0].numVids = 1;
+ depths[0].vids = xalloc(sizeof(VisualID));
+ depths[1].depth = 8;
+ depths[1].numVids = 6;
+ depths[1].vids = xalloc(6*sizeof(VisualID));
+ depths[2].depth = 24;
+ depths[2].numVids = 2;
+ depths[2].vids = xalloc(2*sizeof(VisualID));
+ visuals = xalloc(9*sizeof(VisualRec));
+ v = visuals;
+ /* StaticGray "monochrome" fake */
+ v->vid = FakeClientID(0);
+ v->class = StaticGray;
+ v->bitsPerRGBValue = 1;
+ v->ColormapEntries = 2;
+ v->nplanes = 1;
+ v->redMask = 0;
+ v->greenMask = 0;
+ v->blueMask = 0;
+ v->offsetRed = 0;
+ v->offsetGreen = 0;
+ v->offsetBlue = 0;
+ depths[0].vids[0] = v->vid;
+ /* StaticGray fake */
+ v->vid = FakeClientID(0);
+ v->class = StaticGray;
+ v->bitsPerRGBValue = 8;
+ v->ColormapEntries = 256;
+ v->nplanes = 8;
+ v->redMask = 0;
+ v->greenMask = 0;
+ v->blueMask = 0;
+ v->offsetRed = 0;
+ v->offsetGreen = 0;
+ v->offsetBlue = 0;
+ depths[1].vids[0] = v->vid;
+ /* GrayScale fake */
+ v->vid = FakeClientID(0);
+ v->class = GrayScale;
+ v->bitsPerRGBValue = 8;
+ v->ColormapEntries = 256;
+ v->nplanes = 8;
+ v->redMask = 0;
+ v->greenMask = 0;
+ v->blueMask = 0;
+ v->offsetRed = 0;
+ v->offsetGreen = 0;
+ v->offsetBlue = 0;
+ depths[1].vids[1] = v->vid;
+ /* StaticColor, fake */
+ v->vid = FakeClientID(0);
+ v->class = StaticColor;
+ v->bitsPerRGBValue = 8;
+ v->ColormapEntries = 256;
+ v->nplanes = 8;
+ v->redMask = 0;
+ v->greenMask = 0;
+ v->blueMask = 0;
+ v->offsetRed = 0;
+ v->offsetGreen = 0;
+ v->offsetBlue = 0;
+ depths[1].vids[2] = v->vid;
+ /* PseudoColor, real */
+ /* This is the root visual.  If you change which visual is the root,
+    make sure you update tcx_CreateDefColormap to match. */
+ rootv = v;
+ v->vid = FakeClientID(0);
+ v->class = PseudoColor;
+ v->bitsPerRGBValue = 8;
+ v->ColormapEntries = 256;
+ v->nplanes = 8;
+ v->redMask = 0;
+ v->greenMask = 0;
+ v->blueMask = 0;
+ v->offsetRed = 0;
+ v->offsetGreen = 0;
+ v->offsetBlue = 0;
+ depths[1].vids[3] = v->vid;
+ /* TrueColor, fake */
+ v->vid = FakeClientID(0);
+ v->class = TrueColor;
+ v->bitsPerRGBValue = 3;
+ v->ColormapEntries = 8;
+ v->nplanes = 8;
+ v->redMask = 0x07;
+ v->greenMask = 0x38;
+ v->blueMask = 0xc0;
+ v->offsetRed = 0;
+ v->offsetGreen = 3;
+ v->offsetBlue = 6;
+ depths[1].vids[4] = v->vid;
+ /* DirectColor, fake */
+ v->vid = FakeClientID(0);
+ v->class = DirectColor;
+ v->bitsPerRGBValue = 3;
+ v->ColormapEntries = 8;
+ v->nplanes = 8;
+ v->redMask = 0x07;
+ v->greenMask = 0x38;
+ v->blueMask = 0xc0;
+ v->offsetRed = 0;
+ v->offsetGreen = 3;
+ v->offsetBlue = 6;
+ depths[1].vids[5] = v->vid;
+ /* TrueColor, real */
+ v->vid = FakeClientID(0);
+ v->class = TrueColor;
+ v->bitsPerRGBValue = 8;
+ v->ColormapEntries = 256;
+ v->nplanes = 24;
+ v->redMask = 0x000000ff;
+ v->greenMask = 0x0000ff00;
+ v->blueMask = 0x00ff0000;
+ v->offsetRed = 0;
+ v->offsetGreen = 8;
+ v->offsetBlue = 16;
+ depths[2].vids[0] = v->vid;
+ /* DirectColor, real */
+ v->vid = FakeClientID(0);
+ v->class = DirectColor;
+ v->bitsPerRGBValue = 8;
+ v->ColormapEntries = 256;
+ v->nplanes = 24;
+ v->redMask = 0x000000ff;
+ v->greenMask = 0x0000ff00;
+ v->blueMask = 0x00ff0000;
+ v->offsetRed = 0;
+ v->offsetGreen = 8;
+ v->offsetBlue = 16;
+ depths[2].vids[1] = v->vid;
+ if (vx != 9) abort();
+ miScreenInit( scr, 0, 1152,900, 90,90, 1152,
+	       rootv->depth, 3,depths,
+	       rootv->vid, 9,visuals,
+	       0 );
+ scr->defColormap = FakeClientID(0);
+ scr->minInstalledCmaps = 1;
+ scr->maxInstalledCmaps = 2;
+ scr->backingStoreSupport = NotUseful;
+ scr->saveUnderSupport = NotUseful;
+ scr->blackPixel = 0;
+ scr->whitePixel = 1;
+ scr->devPrivate = 0;
+ scr->CloseScreen = tcx_CloseScreen;
+ scr->QueryBestSize = tcx_QueryBestSize;
+ scr->SaveScreen = tcx_SaveScreen;
+ scr->GetImage = miGetImage; /* XXX */
+ scr->GetSpans = tcx_GetSpans;
+ scr->CreateWindow = tcx_CreateWindow;
+ scr->DestroyWindow = tcx_DestroyWindow;
+ scr->PositionWindow = tcx_PositionWindow;
+ scr->ChangeWindowAttributes = tcx_ChangeWindowAttributes;
+ scr->RealizeWindow = tcx_MapWindow;
+ scr->UnrealizeWindow = tcx_UnmapWindow;
+ /* WindowExposures? */
+ scr->PaintWindowBackground = tcx_PaintWindow;
+ scr->PaintWindowBorder = tcx_PaintWindow;
+ scr->CopyWindow = tcx_CopyWindow;
+ /* ClipNotify? */
+ scr->CreatePixmap = tcx_CreatePixmap;
+ scr->DestroyPixmap = tcx_DestroyPixmap;
+ scr->SaveDoomedAreas = 0;
+ scr->RestoreAreas = 0;
+ scr->ExposeCopy = 0;
+ scr->TranslateBackingStore = 0;
+ scr->ClearBackingStore = 0;
+ scr->DrawGuarantee = 0;
+ scr->RealizeFont = mfbRealizeFont;
+ scr->UnrealizeFont = mfbUnrealizeFont;
+ scr->ConstrainCursor = tcx_ConstrainCursor;
+ scr->CursorLimits = tcx_CursorLimits;
+ scr->DisplayCursor = tcx_DisplayCursor;
+ scr->RealizeCursor = tcx_RealizeCursor;
+ scr->UnrealizeCursor = tcx_UnrealizeCursor;
+ scr->RecolorCursor = tcx_RecolorCursor;
+ scr->SetCursorPosition = tcx_SetCursorPosition;
+ scr->CreateGC = tcx_CreateGC;
+ scr->CreateColormap = tcx_CreateColormap;
+ scr->DestroyColormap = tcx_DestroyColormap;
+ scr->InstallColormap = tcx_InstallColormap;
+ scr->UninstallColormap = tcx_UninstallColormap;
+ scr->ListInstalledColormaps = tcx_ListInstalledColormaps;
+ scr->StoreColors = tcx_StoreColors;
+ scr->ResolveColor = tcx_ResolveColor;
+ scr->BitmapToRegion = mfbPixmapToRegion;
+  { extern void sunBlockHandler();
+    extern void sunWakeupHandler();
+    scr->BlockHandler = sunBlockHandler;
+    scr->WakeupHandler = sunWakeupHandler;
+    scr->blockData = 0;
+    scr->wakeupData = 0;
+  }
+ scr->devPrivate = xalloc(sizeof(TCX24));
+ t->vm1 = vm1;
+ t->vm8 = vm8;
+ t->vm24 = vm24;
+ t->vm32 = vm32;
+ t->bt = bt;
+#if 0
+ t->pm8 = cfbCreatePixmap(scr,0,0,8);
+ if (! t->pm8) return(FALSE);
+ if (! (*scr->ModifyPixmapHeader)(t->pm8,1152,900,8,8,PixmapBytePad(1152,8),vm8)) return(FALSE);
+ t->pm24 = cfb32CreatePixmap(scr,0,0,24);
+ if (! t->pm24) return(FALSE);
+ if (! (*scr->ModifyPixmapHeader)(t->pm24,1152,900,24,32,PixmapBytePad(1152,32),vm24)) return(FALSE);
+#endif
+ if (! tcx_CreateDefaultColormap(scr)) return(FALSE);
+ return(TRUE);
+}
